<?php
    error_reporting(0);
  $env = null; 
  $cwd = "."; 
  $descriptorspec = array ( 
  0 => array ( "pipe" , "r" ),  
  1 => array ( "pipe" , "w" ), 
  ); 

# Set $startDate and $endDate for the period covering the missing data. Format YYYY-MM-DD eg 2021-08-13
$startDate = '2021-01-05';
$endDate = '2021-01-15';

# There should be no need to alter values below here.
$host        = "host = localhost";
$port        = "port = 5432";
$dbname      = "dbname = docmoto";
$credentials = "user = postgres password=postgres";
$db = pg_connect( "$host $port $dbname $credentials"  );
$success = 0;
$failure = 0;

echo "You should only run this after taking a backup of your DocMoto database. Please confirm you have taken a backup of your DocMoto database?  Type 'yes' to continue: ";
$handle = fopen ("php://stdin","r");
$line = fgets($handle);
if(trim($line) != 'yes'){
    echo "Exiting!\n";
    exit;
}
fclose($handle);
echo "\n"; 
   
   if(!$db) {
      echo "Error : Unable to open database\n";
       exit;
   } else {
      echo "Opened database successfully\n";
   }

$sql="select revisionid, storagefilename, collectionpath, documentname
from webdavcollection,webdavdocument, webdavrevision, binmeta, bindata
where collectionpath ilike '/Contents/%'
 and webdavcollection.collectionid=webdavdocument.parentcollectionid
 and binmetaid=xrefbinmeta
 and bindata.bindataid=binmeta.bindataid
 and webdavdocument.historystoreid=webdavrevision.storeid
 and documentname not ilike '%.xml'
 and revisionid>(select coalesce(max(revisionid),0) from webdavrevisionproperties where source='BEXIF')
 and webdavrevision.createtimestamp between '$startDate' and '$endDate' 
 and storageformat=0 
 order by revisionid;";

$ret=pg_query($db,$sql);

 if(!$ret) {
      echo pg_last_error($db);
      exit;
   } 
#echo "Files to processs: " . pg_num_rows($ret) . "\n";
$count=0;

  while ($row = pg_fetch_row($ret))
  {
    $count++;
    $versionid=$row[0];
    $filename=$row[1];
    $collectionPath = $row[2];
    $documentname = $row[3];
    print "Processing $collectionPath$documentname\n";
  $command = escapeshellcmd("exiftool  -json /tmp/afile");	
 $command = escapeshellcmd("exiftool  -json $filename");	


 $process = proc_open($command,$descriptorspec,$pipes,$cwd,$env); 

  if (is_resource($process)) {
   

    $data=stream_get_contents($pipes[1]);
    // echo $data;
    $arr = json_decode($data);
    $sql="";
foreach ($arr as $obj)
{
foreach($obj as $key => $value) {
  // echo $key . " => " . $value . "\n";
   if (strlen($key)>40)
      continue;

    
   if (is_array($value))
      continue;

  if (strlen($value)>100)
      continue; 

   if ($key=='Directory')
      continue;
 
   if ($key=='ExifToolVersion')
      continue;

     //  if ($key=='FileName')
    if (strncmp($key, 'File',4) === 0) 
      continue;
 
   if ($key=='SourceFile')
      continue;
   $sql .= "insert into webdavrevisionproperties(revisionid,source,propertytype, propertyname,propertyvalue) " .
              "  values ($versionid,'BEXIF','string', '$key','" . str_replace("'","''",$value) ."');"; 
    
}
   $tmp=pg_query($db,$sql);
    if (!$tmp)
   {
       print "Failed for $collectionPath $documentname\n";
       $failure++;
    }
    else{
        $success++;
    }
}
    proc_close($process);

}

}
print "Processed $success files with $failure failure(s)\n";
print "Close and re-open DocMoto clients and the missing data should now be visible.\n";

?>
